\section{Implementation}
\label{sec:implementation}

The starting point of this project is the work carried out by
\citet{gatys2015neural} and its tutorial hosted on Google Colab \tutorialref.
The provided code computes successfully the neural style transfer described in \autoref{sec:methodology}. But it was
running on Tensorflow version 1.15. Our first modification is to adapt it to
Tensorflow version 2.4. It only implies some small syntax modifications that
won't be shown in this report.

Apart from that, three main improvements where applied to the original code.
This will allow us to run a significant number of experiments with low effort.

\subsection{Refactor and parametrization}

The original code is fully hosted on a Google Colab repository it is poorly
abstracted and split. Global variables fix some parameters that we would like
to easily modify. The main function only allows to modify 5 hyperparameters,
far from the total number of hyperparameters used in the neural style transfer.
\begin{lstlisting}[language=Python]
def run_style_transfer(content_path, 
                       style_path,
                       num_iterations=1000,
                       content_weight=1e3, 
                       style_weight=1e-2):
    # ...
\end{lstlisting}

We refactored the Google Colab into a traditional Python project with multiple
scripts and hosted it on a
\href{https://gitlab.com/jemaro/wut/neural-networks/style-transfer/-/tree/master}{git repository}. In this way
we have a better version control for collaborative work and we can easily
deploy and execute up to date code in different runtimes, locally or in the
cloud.

Having the code split in several scripts makes easier to parametrize the main
function in a way that all available hyperparameters are input arguments.

\begin{lstlisting}[language=Python]
def run_style_transfer(
    content_path: Path, 
    style_path: Path,
    content_layers: List[str] = ['block5_conv2'],
    style_layers: List[str] = [
        'block1_conv1',
        'block2_conv1',
        'block3_conv1', 
        'block4_conv1', 
        'block5_conv1'
        ],
    pre_training: bool = True, # Pre-training or random initialization of model
    learning_rate: float = 5, # Optimizer parameter
    beta_1: float = 0.99, # Optimizer parameter
    beta_2: float = 0.999, # Optimizer parameter
    epsilon: float = 1e-07, # Optimizer parameter
    amsgrad: bool = False, # Whether to apply AMSGrad variant of the optimizer
    content_weight: float = 1e3, 
    style_weight: float = 1e-2,
    num_iterations: Optional[int] = 1000,
    num_checkpoints: int = CHECKPOINTS_PER_RUN,
    output_folder: Path = OUTPUT_FOLDER,
    verbose: bool = False,
    log_images: bool = False,
    max_iterations: int = 1000,
    save_image_in_checkpoints: bool = False,
    ):
    # ...
\end{lstlisting}

\subsection{Results collection}

The original code requires the user to manually download each result and loss
statistics per iteration were not recorded. We modified the code in a way that
the output images are saved in a user specified folder with a \verb|csv| file
that contains the execution statistics. Additionally, execution logs are
collected in a log file for debugging purposes.

\subsection{Convergence detection}
\label{sec:convergence-detection}

In order to reduce the execution time, we can check if the style transfer has
converged and avoid unnecessary iterations. The simple convergence criterion
shown in  \autoref{eqn:convergence-criterion} has been selected and tested
successfully. It takes into account when the style loss is similar to the
content loss. It is very susceptible to changes of style and content loss
weights but it is simple and intuitive.

\begin{equation}
    \frac{\mathcal{L}_c}{\mathcal{L}_s} > 0.7
    \label{eqn:convergence-criterion}
\end{equation}

Additional auxiliary tools have been built in order to allow quick batch
experiments.

\subsection{Cloud Runner}
Google Colab provides free GPU accelerated runtimes with some limitations.
Therefore an interactive Python notebook has been written in order to quickly
execute experiments from either a Google Colab runtime or your local machine.
This
\href{https://colab.research.google.com/drive/1XBa1_nbnsbZ3bB5SmNoKby3XoE_KnBW8?usp=sharing}{Cloud
Runner} allow us also to save the results directly on Google Drive, which is
very handy for long computations. And we can easily run long computations
because the notebook itself allows to specify lists of hyperparameter values to
be executed one after each other. Moreover, if one specifies a list of values
for two different hyperparameters, all possible combinations will be executed
and saved in Google Drive.

\subsection{Visualization Tool}
Lastly, due to considerable amount of data generated by our experiments. We
developed a
\href{https://colab.research.google.com/drive/17P4Nhsx9FHv8mNE0dbAvBApwZZERusxO?usp=sharing}{Visualization
Tool} using again an interactive Python notebook that can be explored from
Google Colab or locally. \autoref{fig:visualization-tool} shows how this tool
allows us to navigate using sliders the intricate file system that holds a
highly dimensional structure of results, being each dimension a different
hyperparameter.

\begin{figure}
    \includegraphics[width=.4\textwidth]{content/visualization-tool.png}
    \caption{Visualization tool screenshot}
    \label{fig:visualization-tool}
\end{figure}